<?php
/* utf8-marker = äöüß */
/**
 * Morepagedata
 * lets the webmaster change more settings per page
 *
 * @author svasti
 * @date (c)1/2013 by svasti
 * @licence GPL3
 * @link http://www.frankziesing.de/cmsimple/
 * @version 1 beta 4
 */

// Check if PLUGINLOADER is calling
if(!defined('PLUGINLOADER')) {
	die('Plugin '. basename(dirname(__FILE__)) . ' requires a newer version of the Pluginloader. No direct access.');
}

// json function for php 4, supplied by cmb
if (!function_exists('json_encode')) {
    // make sure the class wasn't already included by another plugin
    if (!class_exists('CMB_JSON')) {
	include_once $pth['folder']['plugins'] . 'morepagedata/json.php';
    }
    function json_encode($value)
    {
	$json = CMB_JSON::instance();
	return $json->encode($value);
    }
    function json_decode($string)
    {
	$json = CMB_JSON::instance();
	return $json->decode($string);
    }
}




// Get the field arrays
$mpd = json_decode(file_get_contents($pth['folder']['plugins'].'morepagedata/config/config2.php'),true);

// Add used interests to router
foreach ($mpd['var'] as $key=>$value) {
    if($value) $pd_router -> add_interest($value);
}

// tab for admin-menu
$pd_router -> add_tab($plugin_tx['morepagedata']['tab'], $pth['folder']['plugins'].'morepagedata/morepagedata_view.php');


// Set morepagedata contents.
$mpd_imagelist = $slideshoweffect = $mpd_file = $mpd_plugin = '';

foreach ($mpd['var'] as $key=>$value) {
    if(isset($pd_current[$value]) && $pd_current[$value]){
        $$value = $pd_current[$value];
        if($mpd['type'][$key] == 'html_file') $mpd_file = $$value;
        if($mpd['type'][$key] == 'plugin_call') $mpd_plugin = $$value;
        if($mpd['type'][$key] == 'slide_show') $mpd_imagelist = $$value;
        if($mpd['type'][$key] == 'slide_effect') $slideshoweffect = $$value;
    }
}

// add a function call to a page
if($mpd_plugin && (!$adm OR ($adm && !$edit))) $c[$pd_s] .=  '{{{PLUGIN:'.$mpd_plugin.';}}}';


// Location of possible external files
function mpdFilePath()
{
    global $plugin_cf, $pth;
    return $plugin_cf['morepagedata']['path_html_files']
         ? $plugin_cf['morepagedata']['path_html_files_start_from_content_folder']
            ? $pth['folder']['content'] .$plugin_cf['morepagedata']['path_html_files']
            : $pth['folder']['base'] .$plugin_cf['morepagedata']['path_html_files']
         : $pth['folder']['plugins'] . 'morepagedata/data/';
}
// Add external files to page content
if($mpd_file) {
    $fn = mpdFilePath().$mpd_file;
    $cnt = '';
    if (is_readable($fn) && ($cnt = file_get_contents($fn)) === FALSE) e('cntopen', 'file', $fn);

    if(!$adm OR ($adm && !$edit)) $c[$pd_s] .=  $cnt;
}

// Produce slide show
if($mpd_imagelist) slideShowImages($mpd_imagelist,$slideshoweffect);

function slideShowImages($mpd_imagelist='',$slideshoweffect='')
{
    global $plugin_cf,$hjs,$pth;

    include_once($pth['folder']['plugins'].'jquery/jquery.inc.php');
    include_jQuery();
    if($plugin_cf['morepagedata']['slideshow_standard_effect'] || $slideshoweffect) {
        include_jQueryPlugin('cycle', $pth['folder']['plugins'].'morepagedata/jquery/jquery.cycle.all.js');
        $slideshoweffect = $slideshoweffect? $slideshoweffect : $plugin_cf['morepagedata']['slideshow_standard_effect'];
    } else {
        include_jQueryPlugin('cycle', $pth['folder']['plugins'].'morepagedata/jquery/jquery.cycle.lite.js');
        $slideshoweffect = 'fade';
    }

    $imagearray = explode(',',$mpd_imagelist);
    $src_list = '';
    foreach ($imagearray as $key=>$value) {
        if($value) $src_list .= "\n\t" . '<div>' . tag('img src="'.$pth['folder']['base'].$plugin_cf['morepagedata']['path_slideshow_images'].'/'. $value.'" ') . '</div>';
    }

    $hjs .= '<script type="text/javascript">
(function($) {
    $(document).ready(function() {
        $(\'.slideshow\').cycle({
    		fx: \''.$slideshoweffect.'\',
            speed: '.$plugin_cf['morepagedata']['slideshow_speed'].',
            timeout: '.$plugin_cf['morepagedata']['slideshow_time-out'].'
    	});
    })
})(jQuery)
</script>';

return $src_list;

}
?>
