<?php
/* utf8-marker = äöüß */
/**
 * Morepagedata - module morepagedata_view
 *
 * Creates the menu for the user to change
 * more page data (configurable in admin menu).
 *
 * @author svasti
 * @link http://www.frankziesing.de/cmsimple/
 * @version 1 beta 4
 */

if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}


function morepagedata_view($page){
	global $cf, $c, $cl, $h, $hjs, $l, $plugin, $plugin_cf, $plugin_tx, $pth, $sl, $sn, $su, $tx, $u, $pd_router, $txc;

    $mpd = json_decode(file_get_contents($pth['folder']['plugins'].'morepagedata/config/config2.php'),true);

    // load js color picker if necessary
    if(in_array('color_picker',$mpd['type'])) {
        $hjs .= '<script type="text/javascript" src="'.$pth['folder']['plugins'].'morepagedata/jscolor/jscolor.js"></script>';
    }

    // load slideshow image picker if necessary
    $slideshow_key = array_search('slide_show',$mpd['type']);
    if($slideshow_key !== FALSE) {
        $hjs .= '<script type="text/javascript">
            function addfile(text) {
                var newtext = text;
                document.morepagedata.' . $mpd['var'][$slideshow_key] . '.value += newtext;
            }
        </script>';
    }


    $view  = "\n\n<!-- MorePageData Plugin -->\n";
	$view .= "\n".'<form action="'.$sn.'?'.$su.'" method="post" id="morepagedata" name="morepagedata">';
	$view .= "\n".'<p><b>'.$plugin_tx['morepagedata']['form_title'].'</b></p>' . "\n" . tag('br') . "\n";

  	$help_icon = tag('img src="'.$pth['folder']['plugins']. 'morepagedata/images/help.png" alt="" class="helpicon"');

    $usedtemplate = isset($txc['subsite']['template']) && $txc['subsite']['template']? $txc['subsite']['template'] :$cf['site']['template'];

    //all variable fields set in morepagedata plugin config are gone through
	foreach($mpd['var'] as $key => $field){

        // check if field is only for specific templates
        $templatecheck = $mpd['template'][$key]? explode(',', $mpd['template'][$key]):array();
        if(!$mpd['template'][$key] || in_array($usedtemplate,$templatecheck)) {

            switch ($mpd['type'][$key]) {

                case 'color_picker':
                case 'input_field':
                    $class = $mpd['type'][$key]=='color_picker'? ' class="color"':'';
                    $view .= tag('input type="text" '.$class.' name="'
                          .  $field . '" id="' . $field . '" value="'
                          .  $page[$field] . '"');
            	break;

                case 'textarea':
                    if($plugin_cf['morepagedata']['editor_in_textarea']) init_editor(array('mpd_textarea'),'');
                    $view .= '<textarea class="mpd_textarea" rows="20" cols="20" name="'.$field.'" id="'.$field.'">'
                          .  $page[$field] . '</textarea>';

            	break;

                case 'select_hiddenpage':

                    $pages_select = '';
                    $x = 0;
                    $pd = $pd_router->find_all();
                    for ($i = 0; $i < $cl; $i++) {
                        $levelindicator = '';
                        for ($j=1;$j<$l[$i];$j++) {$levelindicator .= '&ndash;&nbsp;';}
                        if($pd[$i]['linked_to_menu']=='0') {
                            $selectedpage = $levelindicator.$h[$i];
                        	$selected = '';
                        	if($page[$field] == $h[$i]) {$selected = ' selected'; $x++;}
                        	$pages_select .= "\n".'<option value="' .$h[$i] . '"'. $selected.'> &nbsp; '.$selectedpage.'</option>';
                        }
                    }
                    $view .= '<select name="' . $field . '" >'
                          .  "\n" . '<option value=""> &nbsp; ' . $plugin_tx['morepagedata']['default_selection'] . ' &nbsp; </option>'
                          . $pages_select
                          .  "\n" . '</select>';

            	break;

                case 'slide_effect':
                    $effect_select = '';
                    foreach($mpd_slideeffects as $effect){
                    	$selected = '';
                    	if($page[$field] == $effect) {$selected = ' selected';}
                    	$effect_select .= "\n" . '<option  value="'. $effect . '"' . $selected . '> &nbsp; ' . $effect . ' &nbsp; </option>';
                    }
                    $view .= '<select name="' . $field . '" >'
                          .  "\n" . '<option value=""> &nbsp; ' . $plugin_tx['morepagedata']['default_selection'] . ' &nbsp; </option>'
                          .  "\n" . $effect_select
                          .  "\n" . '</select>';
            	break;

                case 'template_image':
                case 'image_folder':

                    $path = $mpd['type'][$key]=='template_image'
                          ? $pth['folder']['template'].$plugin_cf['morepagedata']['path_template_images']
                          : $pth['folder']['base'].$plugin_cf['morepagedata']['path_image_folder'];

                    if(is_dir($path)){

                        $handle=opendir($path);
                        $images = array();
                        while (false !== ($file = readdir($handle))) {
                            if($file != "." && $file != "..") {
                                $images[] = $file;
                            }
                        }
                        closedir($handle);
                        natcasesort($images);
                        $images_select = '';
                        foreach($images as $file){
                        	$selected = '';
                        	if($page[$field] == $file) {$selected = ' selected';}
                        	$images_select .= "\n" . '<option  value="'. $file . '"' . $selected . '> &nbsp; ' . $file . ' &nbsp; </option>';
                        }
                    } else $images_select='';

                    $view .= "\n" . '<select name="' . $field . '" >'
                          .  "\n" . '<option value=""> &nbsp; ' . $plugin_tx['morepagedata']['default_selection'] . ' &nbsp; </option>'
                          .  "\n" . $images_select
                          .  "\n" . '</select>';
            	break;

                case 'html_file':

                    $path = mpdFilePath();

                    $usedfolder = strpos($page[$field],'/')? substr($page[$field], 0, strpos($page[$field],'/')) : '';
                    $usedfile   = strpos($page[$field],'/')? substr($page[$field], (strpos($page[$field],'/')+1)) : $page[$field];

                    // first generate option list to select folder
                    if(is_dir($path)){

                        $handle=opendir($path);
                        $images = array();
                        if ($handle) {
                            while (false !== ($dir = readdir($handle))) {
                                if(strpos($dir,'..')!==0 && is_dir($path.$dir)) {
                                    $folder[] = $dir;
                                }
                            }
                        }
                        closedir($handle);
                        natcasesort($folder);
                        $folder_select = $foundfolder = '';
                        foreach($folder as $folderkey=>$value){
                        	$selected = '';
                        	if( $usedfolder == $value) {$selected = ' selected'; $foundfolder = $folderkey;}
                            if($value=='.')$value='&nbsp; —';
                        	$folder_select .= "\n" . '<option  value="'. $folderkey . '"' . $selected . '>' . $value . '</option>';
                        }
                    } else $folder_select='';

                    // show option list only, when subfolders are found
                    $folderdisplay = $folderkey? '':' style="display:none"';

                    // java script makes a subfolder as option list visible
                    // and gives it the correct name (otherwise all folders will send POST-data)
                    $view .= "\n" . '<select '.$folderdisplay.' OnChange="
                    for (var i = 0; i <= '.$folderkey.'; i++) {

                        if(this.options[this.selectedIndex].value == i ) {
                            document.getElementById(\'f\'+i).style.display = \'block\';
                            document.getElementById(\'file\'+i).name = \''.$field.'\';
                        } else {
                            document.getElementById(\'f\'+i).style.display = \'none\';
                            document.getElementById(\'file\'+i).name = \'\';
                        }
                    }
                    ; " class="mpd_fileselect">'
                          .  "\n" . $folder_select
                          .  "\n" . '</select>';

                    $view .= $folderkey? '&nbsp;' . $plugin_tx['morepagedata']['text_folder'] . tag('br') : '';

                    // now create option lists to select a file in a folder
                    foreach($folder as $folderkey=>$value){
                        if(is_dir($path.'/'.$value)){

                            $handle=opendir($path.'/'.$value);
                            $files = array();
                            if ($handle) {
                                while (false !== ($file = readdir($handle))) {
                                    if(strpos($file,'..')!==0 && is_file($path.$value.'/'.$file)) {
                                        $files[] = $file;
                                    }
                                }
                            }
                            closedir($handle);
                            natcasesort($files);
                            $files_select = '';
                            foreach($files as $file){
                            	$selected = '';
                            	if($usedfile == $file && $foundfolder==$folderkey) {$selected = ' selected';}
                            	$files_select .= "\n" . '<option  value="'. $value.'/'.$file . '"' . $selected . '>' . $file . '</option>';
                            }
                        } else $files_select='';


                        $folderdisplay = $foundfolder == $folderkey? '':' style="display:none"';
                        $fieldname     = $foundfolder == $folderkey? $field : '';

                        $view .= '<div id="f'.$folderkey.'" '.$folderdisplay.' >'
                              .  "\n" . '<select id="file'.$folderkey.'"  name="' . $fieldname . '" class="mpd_fileselect">'
                              .  "\n" . '<option value=""> &nbsp; — &nbsp; </option>'
                              .  "\n" . $files_select
                              .  "\n" . '</select>&nbsp;'
                              .  $plugin_tx['morepagedata']['text_file'] . '</div>';

                    }



            	break;
                case 'slide_show':
                    $view .=  "\n" . ' <label for = "' . $field . '">' .  $mpd['display'][$key] . '</label>' . "\n".tag('br');
                    $view .= '<textarea name="' . $field . '">'
                          .  $page[$field] . '</textarea>'
                          .  "\n" . tag('br');

                    $handle=opendir($pth['folder']['base'].$plugin_cf['morepagedata']['path_slideshow_images']);
                    $images = array();
                    if ($handle) {
                        while (false !== ($file = readdir($handle))) {
                            $fileend = substr($file, -4, 4);
                            if($file != '.'
                                && $file != '..'
                                && !is_dir($pth['folder']['base'].$plugin_cf['morepagedata']['path_slideshow_images'] . '/' . $file)
                                && ($fileend == '.jpg' || $fileend == '.gif' || $fileend == '.png'))
                            {
                                $images[] = $file;
                            }
                        }
                    }
                    closedir($handle);
                    natcasesort($images);
                    foreach ($images as $key2=>$value2) {
                        list($width,$height) = getimagesize($pth['folder']['base'].$plugin_cf['morepagedata']['path_slideshow_images'] . '/' .$value2);
                        $width = $width * 100 / $height;
                    	$images[$key2] = '<a href="javascript:;"  onClick="addfile(\''
                                      . $value2.',\');" class="mpd_imagelist">'.$value2.'<img src="'
                                      . $pth['folder']['base'].$plugin_cf['morepagedata']['path_slideshow_images'] . '/' . $value2
                                      . '" height="100" width="'.$width.'"></a> ';
                    }
                    $mpd_imagelist = implode(' ',$images);
                    $view .= "\n" . $plugin_tx['morepagedata']['select_from'] . "\n" . tag('br')
                          .  "\n" . '<small>' . $mpd_imagelist . '</small>';
            	break;

                case 'checkbox':
                	@$checked =($page[$field] == '1')? ' checked':'';
                	$view .= "\n\t\t"
                          .  tag('input type="hidden" name="'.$field.'" value="0"')
                          .  tag('input type="checkbox" name="'.$field.'" value="1"' . $checked);

            	break;

                case 'option_list':
                case 'plugin_call':
                    $options = explode('|', $mpd['options'][$key]);
                    $options_select = '';
                    foreach($options as $j=>$value){
                    	$selected = '';
                        if($value && $j % 2 == 0) {
                        	if($page[$field] == $value) {$selected = ' selected';}
                            if(!$options[($j+1)]) $options[($j+1)] = $value;
                        	$options_select .= "\n" . '<option value="'. $value . '"' . $selected . '> &nbsp; ' . $options[($j+1)] . ' &nbsp; </option>';
                        }
                    }
                    $view .= '<select name="' . $field . '" >'
                          .  "\n" . '<option value=""> &nbsp; ' . $plugin_tx['morepagedata']['default_selection'] . ' &nbsp; </option>'
                          .  "\n" . $options_select
                          .  "\n" . '</select>';

            	break;
            }

    		if($mpd['type'][$key] == 'color_picker' || $mpd['type'][$key] == 'slide_show') {
                $view .= "\n"
                      .  '<a class="pl_tooltip" href="#">' . $help_icon . '<span>'
                      .  $plugin_tx['morepagedata']['hint_' . $mpd['type'][$key]] . '</span></a>';
            }
    		if($mpd['help'][$key]) {
                $view .= "\n"
                      .  '<a class="pl_tooltip" href="#">' . $help_icon . '<span>'
                      .  $mpd['help'][$key] . '</span></a>';
            }
            $view .= ($mpd['type'][$key] != 'slide_show')
                   ? "\n" . ' <label for = "' . $field . '">' .  $mpd['display'][$key] . '</label>' . "\n".tag('br')
                   : "\n".tag('br');
            $view .= $mpd['hr'][$key]? "\n". tag('br'). tag('hr') : '';
            $view .= tag('br');
        }
	}
	$view .= "\n\t".tag('input name="save_page_data" type="hidden"');
	$view .= "\n\t".'<div style="text-align: right;">';
	$view .= "\n\t\t".tag('input type="submit" value="'.ucfirst($tx['action']['save']).'"').tag('br');
	$view .= "\n\t".'</div>';
	$view .= "\n".'</form>';
	return $view;
}
?>
